const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const stock_reception_items = sequelize.define(
    'stock_reception_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity_received: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_cost_ht: {
        type: DataTypes.DECIMAL,
      
      

      },

expiry_date: {
        type: DataTypes.DATE,
      
      

      },

batch_code: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  stock_reception_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






































//end loop



    db.stock_reception_items.belongsTo(db.stock_receptions, {
      as: 'stock_reception',
      foreignKey: {
        name: 'stock_receptionId',
      },
      constraints: false,
    });

    db.stock_reception_items.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.stock_reception_items.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.stock_reception_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.stock_reception_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return stock_reception_items;
};


